(function( $ ) {
    $.fn.fixOnTop = function(options) 
    {
        this.each(function()
        {
            $(this).attr( "data-pos", $(this).offset().top - $(this).innerHeight()-20 );
        });
        
        var fixOnTopElements = this;

        var fixOnTopFunction = function(e)
        { 
            var hiddenElements = [];
            var normalElements = [];
            var lastFixedElement = false;
            
            fixOnTopElements.each(function()
            {
                if( $(window).scrollTop() >= $(this).attr( "data-pos" ) )
                {
                    if(lastFixedElement !== false)
                    {
                        hiddenElements.push( lastFixedElement );
                    }
                    lastFixedElement = $(this);
                }
                else
                {
                    normalElements.push( $(this) );
                }
            });
            
            $.each( hiddenElements , function( index, $this ) 
            {
               if(  $this.hasClass("fixed")  ) $this.removeClass("fixed");
               if( !$this.hasClass("hidden") ) $this.addClass("hidden");
            });
            
            if(lastFixedElement !== false)
            {
                if(  lastFixedElement.hasClass("hidden")) lastFixedElement.removeClass("hidden");
                if( !lastFixedElement.hasClass("fixed"))  lastFixedElement.addClass("fixed");
                
                if($("header h1.last").text() != lastFixedElement.text())
                {
                    // attach text
                    var headers = $("header").find("h1");
                    if( $(headers[0]).hasClass("last") )
                    {
                        $(headers[0]).removeClass("last").addClass("hidden");
                        $(headers[1]).addClass("last").html(lastFixedElement.text());
                    }
                    else
                    {
                        $(headers[1]).removeClass("last").addClass("hidden");
                        $(headers[0]).addClass("last").html(lastFixedElement.text());
                    }
                }

            }
                        
            $.each( normalElements , function( index, $this ) 
            {
               if(  $this.hasClass("fixed")  ) $this.removeClass("fixed");
               if(  $this.hasClass("hidden") ) $this.removeClass("hidden");
            });
        };
        
        $(window).scroll(function(e){ fixOnTopFunction() });
        
        // create while first declaration
        fixOnTopFunction();
        
        return this;		
  };
}( jQuery ));